import { RequestBlockCache } from 'react-request-block';
var cache = null;

function create(_ref) {
  var cache = _ref.cache;

  if (cache && cache instanceof RequestBlockCache) {
    return cache;
  }

  return new RequestBlockCache(cache, !!process.browser === false);
}

export default function initRequestBlockCache(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  if (!process.browser) {
    return create(initialState);
  }

  if (!cache) {
    cache = create(initialState);
  }

  return cache;
}