import _regeneratorRuntime from "@babel/runtime/regenerator";
import _extends from "@babel/runtime/helpers/extends";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import Head from 'next/head';
import { RequestBlockProvider, getDataFromTree } from 'react-request-block';
import { getDisplayName } from './hoc-utils';
import initRequestBlockCache from './initRequestBlockCache';

var Flatted = require('flatted/cjs');

export default (function (config) {
  var _ref = config || {},
      origin = _ref.origin,
      options = _ref.options;

  return function (ComposedComponent) {
    var _class, _temp;

    var propTypes = {
      requestBlockState: PropTypes.shape()
    };
    var defaultProps = {
      requestBlockState: null
    };
    var RequestBlock = (_temp = _class =
    /*#__PURE__*/
    function (_React$Component) {
      _inheritsLoose(RequestBlock, _React$Component);

      function RequestBlock(props) {
        var _this;

        _this = _React$Component.call(this, props) || this;
        _this.requestBlockCache = initRequestBlockCache(props.requestBlockState);
        return _this;
      }

      RequestBlock.getInitialProps =
      /*#__PURE__*/
      function () {
        var _getInitialProps = _asyncToGenerator(
        /*#__PURE__*/
        _regeneratorRuntime.mark(function _callee(props) {
          var Component, router, ctx, composedInitialProps, requestBlockCache, req, host, defaultOrigin, requestBlockState;
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  Component = props.Component, router = props.router, ctx = props.ctx;
                  composedInitialProps = {};

                  if (!ComposedComponent.getInitialProps) {
                    _context.next = 6;
                    break;
                  }

                  _context.next = 5;
                  return ComposedComponent.getInitialProps(props);

                case 5:
                  composedInitialProps = _context.sent;

                case 6:
                  // Run all RequestBlock queries in the component tree
                  // and extract the resulting data
                  requestBlockCache = initRequestBlockCache();

                  if (process.browser) {
                    _context.next = 20;
                    break;
                  }

                  req = ctx.req;
                  host = req.headers.host;
                  defaultOrigin = "" + (req && req.connection && req.connection.encrypted ? 'https://' : 'http://') + host;
                  _context.prev = 11;
                  _context.next = 14;
                  return getDataFromTree(React.createElement(RequestBlockProvider, {
                    cache: requestBlockCache,
                    origin: origin || defaultOrigin,
                    options: options
                  }, React.createElement(ComposedComponent, _extends({
                    Component: Component,
                    ctx: ctx,
                    router: router,
                    store: ctx.store
                  }, composedInitialProps))));

                case 14:
                  _context.next = 19;
                  break;

                case 16:
                  _context.prev = 16;
                  _context.t0 = _context["catch"](11);

                  // Prevent errors from crashing SSR.
                  // Handle them in components via the data.error prop:
                  if (process.env.NODE_ENV === 'development') {
                    console.log(_context.t0);
                  }

                case 19:
                  // getDataFromTree does not call componentWillUnmount
                  // head side effect therefore need to be cleared manually
                  Head.rewind();

                case 20:
                  // Pass in the initial cache state
                  requestBlockState = {
                    cache: Flatted.stringify(requestBlockCache.extract()),
                    origin: origin
                  };
                  return _context.abrupt("return", _objectSpread({}, composedInitialProps, {
                    requestBlockState: requestBlockState
                  }));

                case 22:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[11, 16]]);
        }));

        function getInitialProps(_x) {
          return _getInitialProps.apply(this, arguments);
        }

        return getInitialProps;
      }();

      var _proto = RequestBlock.prototype;

      _proto.render = function render() {
        return React.createElement(RequestBlockProvider, {
          cache: this.requestBlockCache,
          origin: origin || '',
          options: options
        }, React.createElement(ComposedComponent, this.props));
      };

      return RequestBlock;
    }(React.Component), _defineProperty(_class, "displayName", "withRequestBlock(" + getDisplayName(ComposedComponent) + ")"), _temp);
    RequestBlock.propTypes = propTypes;
    RequestBlock.defaultProps = defaultProps;
    return RequestBlock;
  };
});