"use strict";

exports.__esModule = true;
exports["default"] = initRequestBlockCache;

var _reactRequestBlock = require("react-request-block");

var cache = null;

function create(_ref) {
  var cache = _ref.cache;

  if (cache && cache instanceof _reactRequestBlock.RequestBlockCache) {
    return cache;
  }

  return new _reactRequestBlock.RequestBlockCache(cache, !!process.browser === false);
}

function initRequestBlockCache(initialState) {
  if (initialState === void 0) {
    initialState = {};
  }

  if (!process.browser) {
    return create(initialState);
  }

  if (!cache) {
    cache = create(initialState);
  }

  return cache;
}