"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _head = _interopRequireDefault(require("next/head"));

var _reactRequestBlock = require("react-request-block");

var _hocUtils = require("./hoc-utils");

var _initRequestBlockCache = _interopRequireDefault(require("./initRequestBlockCache"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Flatted = require('flatted/cjs');

var _default = function _default(config) {
  var _ref = config || {},
      origin = _ref.origin,
      options = _ref.options;

  return function (ComposedComponent) {
    var _class, _temp;

    var propTypes = {
      requestBlockState: _propTypes["default"].shape()
    };
    var defaultProps = {
      requestBlockState: null
    };
    var RequestBlock = (_temp = _class =
    /*#__PURE__*/
    function (_React$Component) {
      (0, _inheritsLoose2["default"])(RequestBlock, _React$Component);

      function RequestBlock(props) {
        var _this;

        _this = _React$Component.call(this, props) || this;
        _this.requestBlockCache = (0, _initRequestBlockCache["default"])(props.requestBlockState);
        return _this;
      }

      RequestBlock.getInitialProps =
      /*#__PURE__*/
      function () {
        var _getInitialProps = (0, _asyncToGenerator2["default"])(
        /*#__PURE__*/
        _regenerator["default"].mark(function _callee(props) {
          var Component, router, ctx, composedInitialProps, requestBlockCache, req, host, defaultOrigin, requestBlockState;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  Component = props.Component, router = props.router, ctx = props.ctx;
                  composedInitialProps = {};

                  if (!ComposedComponent.getInitialProps) {
                    _context.next = 6;
                    break;
                  }

                  _context.next = 5;
                  return ComposedComponent.getInitialProps(props);

                case 5:
                  composedInitialProps = _context.sent;

                case 6:
                  // Run all RequestBlock queries in the component tree
                  // and extract the resulting data
                  requestBlockCache = (0, _initRequestBlockCache["default"])();

                  if (process.browser) {
                    _context.next = 20;
                    break;
                  }

                  req = ctx.req;
                  host = req.headers.host;
                  defaultOrigin = "" + (req && req.connection && req.connection.encrypted ? 'https://' : 'http://') + host;
                  _context.prev = 11;
                  _context.next = 14;
                  return (0, _reactRequestBlock.getDataFromTree)(_react["default"].createElement(_reactRequestBlock.RequestBlockProvider, {
                    cache: requestBlockCache,
                    origin: origin || defaultOrigin,
                    options: options
                  }, _react["default"].createElement(ComposedComponent, (0, _extends2["default"])({
                    Component: Component,
                    ctx: ctx,
                    router: router,
                    store: ctx.store
                  }, composedInitialProps))));

                case 14:
                  _context.next = 19;
                  break;

                case 16:
                  _context.prev = 16;
                  _context.t0 = _context["catch"](11);

                  // Prevent errors from crashing SSR.
                  // Handle them in components via the data.error prop:
                  if (process.env.NODE_ENV === 'development') {
                    console.log(_context.t0);
                  }

                case 19:
                  // getDataFromTree does not call componentWillUnmount
                  // head side effect therefore need to be cleared manually
                  _head["default"].rewind();

                case 20:
                  // Pass in the initial cache state
                  requestBlockState = {
                    cache: Flatted.stringify(requestBlockCache.extract()),
                    origin: origin
                  };
                  return _context.abrupt("return", _objectSpread({}, composedInitialProps, {
                    requestBlockState: requestBlockState
                  }));

                case 22:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[11, 16]]);
        }));

        function getInitialProps(_x) {
          return _getInitialProps.apply(this, arguments);
        }

        return getInitialProps;
      }();

      var _proto = RequestBlock.prototype;

      _proto.render = function render() {
        return _react["default"].createElement(_reactRequestBlock.RequestBlockProvider, {
          cache: this.requestBlockCache,
          origin: origin || '',
          options: options
        }, _react["default"].createElement(ComposedComponent, this.props));
      };

      return RequestBlock;
    }(_react["default"].Component), (0, _defineProperty2["default"])(_class, "displayName", "withRequestBlock(" + (0, _hocUtils.getDisplayName)(ComposedComponent) + ")"), _temp);
    RequestBlock.propTypes = propTypes;
    RequestBlock.defaultProps = defaultProps;
    return RequestBlock;
  };
};

exports["default"] = _default;